/*
 * Procedury_Demo_FT801.c
 *
 *	procedury demonstracyjne dla wywietlacza Riverdi z ukadem graficznym FT801
 *  Created on: 28 gru 2015
 *      Author: Rysiek www.arskam.com
 */
// AN_312 FT800 header
#include "FT800.h"
#include "FT801_procedury.h"
#include "FT801_funkcje.h"
#include "Procedury_Demo_FT801.h"
#include "Demo_Obrazy.h"

unsigned char blokada_zmiany =1;
unsigned char aktywny_ekran;

unsigned char num_obrazka_do_wyswietlenia;
unsigned char poziom_wyciemnienia, rozjasnianie;
uint32_t back_Tick, odliczanie_10ms, odliczanie_3_6_s;

//Page1
//wywietlanie i obsuga gwnej strony programu demo
void Page1_Obsluga(void)
{
extern unsigned int cmdOffset;												// Used to navigate command rung buffer
extern unsigned char aktywna_strona;
#define TOGGLE1_TAG	1UL
unsigned int reg_tag;

	//kontrola dotknicia Toggle1
	if (blokada_zmiany ==1) HAL_Delay(500);
	reg_tag =ft800memRead32(REG_TOUCH_TAG);
	reg_tag =reg_tag & 0xFFFF;
	if (reg_tag ==TOGGLE1_TAG && blokada_zmiany !=1)
	{
		//zerowanie 2 buforu obrazka w RAM_G
		ft800memWrite32(RAM_CMD + cmdOffset, (CMD_MEMZERO));
		cmdOffset = incCMDOffset(cmdOffset, 4);
		ft800memWrite32(RAM_CMD + cmdOffset, (BUFOR_OBRAZKA_2));
		cmdOffset = incCMDOffset(cmdOffset, 4);
		ft800memWrite32(RAM_CMD + cmdOffset, (BUFOR_OBRAZKA_2));
		cmdOffset = incCMDOffset(cmdOffset, 4);

		aktywny_ekran =EKRAN_2_0;
		Page2_Obsluga();
		aktywna_strona =AKTYWNA_STRONA_2;
		blokada_zmiany =1;
		return;
	}
	if (reg_tag !=TOGGLE1_TAG) blokada_zmiany =0;

/*
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_CLEAR_RGB | BLACK));																											// Set the default clear color to black
	cmdOffset = incCMDOffset(cmdOffset, 4);								// Update the command pointer
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_CLEAR | CLR_COL | CLR_STN | CLR_TAG));																											// Clear the screen - this and the previous prevent artifacts between lists																											// Attributes are the color, stencil and tag buffers
	cmdOffset = incCMDOffset(cmdOffset, 4);								// Update the command pointer

	ft800memWrite32(RAM_CMD + cmdOffset, (DL_SAVE_CONTEXT));
	cmdOffset = incCMDOffset(cmdOffset, 4);
*/
//Text1
	FT80x_F_DL_Color_RGB(&cmdOffset, 255, 255, 255);
s_cmd_txt cmd_txt;
	cmd_txt.x =299;
	cmd_txt.y =33;
	cmd_txt.font =31;
	cmd_txt.options =OPT_CENTER;
	cmd_txt.s ="Test wyswietlacza";
	FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

	ft800memWrite32(RAM_CMD + cmdOffset, (DL_RESTORE_CONTEXT));
	cmdOffset = incCMDOffset(cmdOffset, 4);
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_SAVE_CONTEXT));
	cmdOffset = incCMDOffset(cmdOffset, 4);
//Text2
	FT80x_F_DL_Color_RGB(&cmdOffset, 0, 255, 0);
	cmd_txt.x =311;
	cmd_txt.y =78;
	cmd_txt.font =24;
	cmd_txt.options =OPT_CENTER;
	cmd_txt.s ="RVT4.3B480272CFWC81";
	FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

	ft800memWrite32(RAM_CMD + cmdOffset, (DL_RESTORE_CONTEXT));
	cmdOffset = incCMDOffset(cmdOffset, 4);
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_SAVE_CONTEXT));
	cmdOffset = incCMDOffset(cmdOffset, 4);
//Text3
	FT80x_F_DL_Color_RGB(&cmdOffset, 0, 255, 0);
	cmd_txt.x =305;
	cmd_txt.y =110;
	cmd_txt.font =24;
	cmd_txt.options =OPT_CENTER;
	cmd_txt.s ="firmy Riverdi";
	FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

	ft800memWrite32(RAM_CMD + cmdOffset, (DL_RESTORE_CONTEXT));
	cmdOffset = incCMDOffset(cmdOffset, 4);
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_SAVE_CONTEXT));
	cmdOffset = incCMDOffset(cmdOffset, 4);
//Logo
extern const unsigned char Logo_AVT_tab[];
s_f_picture f_picture;
	f_picture.p_pict_buf =(unsigned char *)&Logo_AVT_tab[0];
	f_picture.siz_h =105;
	f_picture.siz_w =105;
	f_picture.x =14;
	f_picture.y =17;
	FT80x_F_Picture(&cmdOffset, f_picture);

	ft800memWrite32(RAM_CMD + cmdOffset, (DL_RESTORE_CONTEXT));
	cmdOffset = incCMDOffset(cmdOffset, 4);
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_SAVE_CONTEXT));
	cmdOffset = incCMDOffset(cmdOffset, 4);
//Toggle1
	FT80x_F_DL_Color_RGB(&cmdOffset, 255, 255, 255);
s_cmd_toggle cmd_toggle;
	cmd_toggle.x =30;
	cmd_toggle.y =240;
	cmd_toggle.w =67;
	cmd_toggle.font =27;
	cmd_toggle.options =0;
	cmd_toggle.state =0;
	cmd_toggle.s ="START\xffSTOP";
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_TAG | TOGGLE1_TAG));
	cmdOffset = incCMDOffset(cmdOffset, 4);
	FT80x_F_CMD_Toggle(&cmdOffset, cmd_toggle);

}
//Page2
//wywietlanie i obsuga strony 2 programu demo
void Page2_Obsluga(void)
{
extern unsigned int cmdOffset, cmdBufferRd, cmdBufferWr;
extern unsigned char aktywna_strona;
unsigned int reg_tag;
unsigned char kl_nacisniety =0;
#define TOGGLE2_TAG			2UL
#define BUTTON_BITMAP_TAG	3UL
#define BUTTON_NASTAW_TAG	4UL
#define BUTTON_GRAFIK_TAG	5UL

	//kontrola dotknicia Toggle1
	if (blokada_zmiany ==1) HAL_Delay(500);
	reg_tag =ft800memRead32(REG_TOUCH_TAG);
	reg_tag =reg_tag & 0xFFFF;
	if (reg_tag ==TOGGLE2_TAG && blokada_zmiany !=1)
	{
		//przeciwdziaanie wywietlania niepodanych artefaktw przed powrotem na stron Page1
		FT80x_F_DL_End(&cmdOffset);
		FT80x_F_DL_Start(&cmdBufferRd, &cmdBufferWr, &cmdOffset);

		Page1_Obsluga();
		aktywna_strona =AKTYWNA_STRONA_1;
		blokada_zmiany =1;
		return;
	}
	if (reg_tag !=TOGGLE2_TAG) blokada_zmiany =0;
	switch (reg_tag)
	{
		case BUTTON_BITMAP_TAG:
		{
			aktywny_ekran =EKRAN_2_1;
			kl_nacisniety =1;
			break;
		}
		case BUTTON_NASTAW_TAG:
		{
			aktywny_ekran =EKRAN_2_2;
			kl_nacisniety =1;
			break;
		}
		case BUTTON_GRAFIK_TAG:
		{
			aktywny_ekran =EKRAN_2_3;
			odliczanie_3_6_s =0;
			break;
		}
		default:
		{
			kl_nacisniety =0;
			break;
		}
	}

	ft800memWrite32(RAM_CMD + cmdOffset, (DL_CLEAR_RGB | BLACK));																											// Set the default clear color to black
	cmdOffset = incCMDOffset(cmdOffset, 4);								// Update the command pointer
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_CLEAR | CLR_COL | CLR_STN | CLR_TAG));																											// Clear the screen - this and the previous prevent artifacts between lists																											// Attributes are the color, stencil and tag buffers
	cmdOffset = incCMDOffset(cmdOffset, 4);								// Update the command pointer

	ft800memWrite32(RAM_CMD + cmdOffset, (DL_SAVE_CONTEXT));
	cmdOffset = incCMDOffset(cmdOffset, 4);
	//Toggle1
	FT80x_F_DL_Color_RGB(&cmdOffset, 255, 255, 255);
s_cmd_toggle cmd_toggle;
	cmd_toggle.x =30;
	cmd_toggle.y =240;
	cmd_toggle.w =67;
	cmd_toggle.font =27;
	cmd_toggle.options =0;
	cmd_toggle.state =STATE_ON;
	cmd_toggle.s ="START\xffSTOP";
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_TAG | TOGGLE2_TAG));
	cmdOffset = incCMDOffset(cmdOffset, 4);
	FT80x_F_CMD_Toggle(&cmdOffset, cmd_toggle);
	//Button_bitmapy
s_cmd_button cmd_button;
	cmd_button.x =15;
	cmd_button.y =15;
	cmd_button.siz_w =118;
	cmd_button.siz_h =41;
	cmd_button.font =24;
	if (aktywny_ekran ==EKRAN_2_1)  //przycisk nacinity
	{
		cmd_button.options =256;
		cmd_button.fgcolor =0x003b76;
		cmd_button.color_RGB_tab[0] =0;
		cmd_button.color_RGB_tab[1] =128;
		cmd_button.color_RGB_tab[2] =255;
	}
	else 								//przycisk zwolniony
	{
		cmd_button.options =0;
		cmd_button.fgcolor =0x004f9f;
		cmd_button.color_RGB_tab[0] =0;
		cmd_button.color_RGB_tab[1] =32;
		cmd_button.color_RGB_tab[2] =64;
	}
	cmd_button.gradcolor =0xffffff;
	cmd_button.s ="bitmapy";
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_TAG | BUTTON_BITMAP_TAG));
	cmdOffset = incCMDOffset(cmdOffset, 4);
	FT80x_F_CMD_Button(&cmdOffset, cmd_button);
	//Button_nastawy
	cmd_button.x =15;
	cmd_button.y =75;
	//j.w.
	if (aktywny_ekran ==EKRAN_2_2)  //przycisk nacinity
	{
		cmd_button.options =256;
		cmd_button.fgcolor =0x003b76;
		cmd_button.color_RGB_tab[0] =0;
		cmd_button.color_RGB_tab[1] =128;
		cmd_button.color_RGB_tab[2] =255;
	}
	else 								//przycisk zwolniony
	{
		cmd_button.options =0;
		cmd_button.fgcolor =0x004f9f;
		cmd_button.color_RGB_tab[0] =0;
		cmd_button.color_RGB_tab[1] =32;
		cmd_button.color_RGB_tab[2] =64;
	}
	cmd_button.s ="nastawy";
	//j.w.
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_TAG | BUTTON_NASTAW_TAG));
	cmdOffset = incCMDOffset(cmdOffset, 4);
	FT80x_F_CMD_Button(&cmdOffset, cmd_button);
	//Button_wskazniki
	cmd_button.x =15;
	cmd_button.y =135;
	//j.w.
	if (aktywny_ekran ==EKRAN_2_3)  //przycisk nacinity
	{
		cmd_button.options =256;
		cmd_button.fgcolor =0x003b76;
		cmd_button.color_RGB_tab[0] =0;
		cmd_button.color_RGB_tab[1] =128;
		cmd_button.color_RGB_tab[2] =255;
	}
	else 								//przycisk zwolniony
	{
		cmd_button.options =0;
		cmd_button.fgcolor =0x004f9f;
		cmd_button.color_RGB_tab[0] =0;
		cmd_button.color_RGB_tab[1] =32;
		cmd_button.color_RGB_tab[2] =64;
	}
	cmd_button.s ="grafika";
	//j.w.
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_TAG | BUTTON_GRAFIK_TAG));
	cmdOffset = incCMDOffset(cmdOffset, 4);
	FT80x_F_CMD_Button(&cmdOffset, cmd_button);
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_RESTORE_CONTEXT));
	cmdOffset = incCMDOffset(cmdOffset, 4);
	//anulowanie przypisania tagu do kolejnych wywietlanych elementw
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_TAG));
	cmdOffset = incCMDOffset(cmdOffset, 4);

	//obsuga scenariuszy demo
	switch (aktywny_ekran)
	{
		case EKRAN_2_1:
		{
			Obsluga_Demo_Bitmapy(kl_nacisniety);
			break;
		}
		case EKRAN_2_2:
		{
			Obsluga_Demo_Nastawy(kl_nacisniety);
			break;
		}
		case EKRAN_2_3:
		{
			Obsluga_Demo_Grafika();
			break;
		}
	}

}
//---------------------------------------
//demo: bitmapy
//---------------------------------------
//demo: bitmapy
//obsuga demonstacji wywietlanie bitmap
void Demo_Bitmapy(unsigned char inicjacja_procedury, s_f_picture f_picture)
{
extern unsigned int cmdOffset;

	f_picture.siz_h =218;
	f_picture.siz_w =290;
	f_picture.x =170;
	f_picture.y =15;
	FT80x_F_Picture_v2(&cmdOffset, f_picture);

	ft800memWrite32(RAM_CMD + cmdOffset, (DL_RESTORE_CONTEXT));
	cmdOffset = incCMDOffset(cmdOffset, 4);
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_SAVE_CONTEXT));
	cmdOffset = incCMDOffset(cmdOffset, 4);

}
//---------------------------------------
//demo: nastawy
void Obsluga_Demo_Bitmapy(unsigned char inicjacja_procedury)
{
const unsigned char *p_obrazek_tab[] ={&Gory1_tab[0], &Morze1_tab[0], &Ziemia1_tab[0]};
s_f_picture f_picture;
extern unsigned int cmdOffset;

	if (inicjacja_procedury ==1)
	{
		//inicjacja procedury po naciniciu klawisza "bitmapy"
		num_obrazka_do_wyswietlenia =0;
		poziom_wyciemnienia =1;
		rozjasnianie =1;
		f_picture.p_pict_buf =(unsigned char *)p_obrazek_tab[num_obrazka_do_wyswietlenia];
		f_picture.color_a =poziom_wyciemnienia;
		f_picture.pic_in_ram_g =0;//dane obrazka do buforu
		f_picture.adr_in_ram_g =BUFOR_OBRAZKA_1;
		Demo_Bitmapy(0, f_picture);
		odliczanie_10ms =10;
		back_Tick =HAL_GetTick();
		return;
	}
	if (odliczanie_10ms ==0)
	{
		if ((poziom_wyciemnienia <255) && (rozjasnianie ==1))
		{
			poziom_wyciemnienia++;
			//ustawienie kolejnego poziomu rozjaniania
			f_picture.color_a =poziom_wyciemnienia;
			f_picture.adr_in_ram_g =BUFOR_OBRAZKA_1;
			f_picture.pic_in_ram_g =1;//dane obrazka s w buforze
			Demo_Bitmapy(1, f_picture);
			odliczanie_10ms =10;
			back_Tick =HAL_GetTick();
			return;
		}
		else
		{
			rozjasnianie =0;
		}
		if ((poziom_wyciemnienia >0) && (rozjasnianie ==0))
		{
			poziom_wyciemnienia--;
			//ustawienie kolejnego poziomu przyciemniania
			f_picture.color_a =poziom_wyciemnienia;
			f_picture.adr_in_ram_g =BUFOR_OBRAZKA_1;
			f_picture.pic_in_ram_g =1;//dane obrazka s w buforze
			Demo_Bitmapy(1, f_picture);
			odliczanie_10ms =10;
			back_Tick =HAL_GetTick();
			return;
		}
		else
		{
			//inicjacja wywietlania nastpnego obrazka
			num_obrazka_do_wyswietlenia++;
			if (num_obrazka_do_wyswietlenia >=3) num_obrazka_do_wyswietlenia =0;
			poziom_wyciemnienia =1;
			rozjasnianie =1;
			f_picture.p_pict_buf =(unsigned char *)p_obrazek_tab[num_obrazka_do_wyswietlenia];
			f_picture.color_a =poziom_wyciemnienia;
			f_picture.pic_in_ram_g =0;//dane obrazka do buforu
			f_picture.adr_in_ram_g =BUFOR_OBRAZKA_1;
			Demo_Bitmapy(0, f_picture);
			odliczanie_10ms =10;
			back_Tick =HAL_GetTick();
			return;
		}
	}
}
void Obsluga_Demo_Nastawy(unsigned char inicjacja_procedury)
{
extern unsigned int cmdOffset;
static s_cmd_clock cmd_clock;
static s_cmd_gauge cmd_gauge;
static s_cmd_dial cmd_dial;
static s_cmd_slider cmd_slider;
static s_cmd_spinner cmd_spinner;
static char gauge_up=1, dial_up=1, slider_up=1;

	if (inicjacja_procedury ==1)
	{
		//zegar RTC
		cmd_clock.bgcolor =0x002040;
		cmd_clock.color_RGB_tab[0] =128;
		cmd_clock.color_RGB_tab[1] =128;
		cmd_clock.color_RGB_tab[2] =128;

		cmd_clock.x =200;
		cmd_clock.y =70;
		cmd_clock.r =50;
		cmd_clock.options =OPT_3D;
		cmd_clock.h =3;
		cmd_clock.m =50;
		cmd_clock.s =10;
		cmd_clock.ms =0;
		FT80x_F_CMD_Clock(&cmdOffset, cmd_clock);
		//wskanik zegarowy
		cmd_gauge.bgcolor =0x008500;
		cmd_gauge.color_RGB_tab[0] =170;
		cmd_gauge.color_RGB_tab[1] =0;
		cmd_gauge.color_RGB_tab[2] =127;

		cmd_gauge.x =310;
		cmd_gauge.y =70;
		cmd_gauge.r =50;
		cmd_gauge.options =OPT_3D;
		cmd_gauge.maior =5;
		cmd_gauge.minor =5;
		cmd_gauge.val =150;
		cmd_gauge.range =300;
		FT80x_F_CMD_Gauge(&cmdOffset, cmd_gauge);
		//pokrto

		cmd_dial.fgcolor =0x9E9E9E;
		cmd_dial.color_RGB_tab[0] =0;
		cmd_dial.color_RGB_tab[1] =0;
		cmd_dial.color_RGB_tab[2] =0;

		cmd_dial.x =420;
		cmd_dial.y =70;
		cmd_dial.r =50;
		cmd_dial.options =OPT_3D;
		cmd_dial.val =0x10000/2;
		FT80x_F_CMD_Dial(&cmdOffset, cmd_dial);

		ft800memWrite32(RAM_CMD + cmdOffset, (DL_RESTORE_CONTEXT));
		cmdOffset = incCMDOffset(cmdOffset, 4);
		ft800memWrite32(RAM_CMD + cmdOffset, (DL_SAVE_CONTEXT));
		cmdOffset = incCMDOffset(cmdOffset, 4);

		//suwak
		cmd_slider.fgcolor =0xFFFFFF;
		cmd_slider.bgcolor =0x002040;
		cmd_slider.x =160;
		cmd_slider.y =150;
		cmd_slider.w =290;
		cmd_slider.h =10;
		cmd_slider.options =OPT_3D;
		cmd_slider.val =150;
		cmd_slider.range =300;
		FT80x_F_CMD_Slider(&cmdOffset, cmd_slider);

		ft800memWrite32(RAM_CMD + cmdOffset, (DL_RESTORE_CONTEXT));
		cmdOffset = incCMDOffset(cmdOffset, 4);
		ft800memWrite32(RAM_CMD + cmdOffset, (DL_SAVE_CONTEXT));
		cmdOffset = incCMDOffset(cmdOffset, 4);

		//sygnalizator (poczekajka)
		cmd_spinner.color_RGB_tab[0] =255;
		cmd_spinner.color_RGB_tab[1] =255;
		cmd_spinner.color_RGB_tab[2] =255;

		cmd_spinner.x =200;
		cmd_spinner.y =230;
		cmd_spinner.style =0;
		cmd_spinner.scale =0;
		FT80x_F_CMD_Spinner(&cmdOffset, cmd_spinner);

		ft800memWrite32(RAM_CMD + cmdOffset, (DL_RESTORE_CONTEXT));
		cmdOffset = incCMDOffset(cmdOffset, 4);
		ft800memWrite32(RAM_CMD + cmdOffset, (DL_SAVE_CONTEXT));
		cmdOffset = incCMDOffset(cmdOffset, 4);

		ft800memWrite32(RAM_CMD + cmdOffset, CMD_FGCOLOR);
		cmdOffset = incCMDOffset(cmdOffset, 4);
		ft800memWrite32(RAM_CMD + cmdOffset, 0x0059b3);
		cmdOffset = incCMDOffset(cmdOffset, 4);

	}
	else
	{
		//zegar RTC
		cmd_clock.ms =cmd_clock.ms +15;
		if (cmd_clock.ms >=1000)
		{
			cmd_clock.ms =0;
			cmd_clock.s++;
			if (cmd_clock.s >=60)
			{
				cmd_clock.s =0;
				cmd_clock.m++;
				if (cmd_clock.m >=60)
				{
					cmd_clock.m =0;
					cmd_clock.h++;
					if (cmd_clock.h >=12) cmd_clock.h =0;
				}
			}
		}
		cmd_clock.bgcolor =0x002040;
		cmd_clock.color_RGB_tab[0] =128;
		cmd_clock.color_RGB_tab[1] =128;
		cmd_clock.color_RGB_tab[2] =128;
		FT80x_F_CMD_Clock(&cmdOffset, cmd_clock);
		//wskanik zegarowy
		if (gauge_up ==1)
		{
			if (cmd_gauge.val >=cmd_gauge.range) gauge_up =0;
			else cmd_gauge.val++;
		}
		else
		{
			if (cmd_gauge.val ==0) gauge_up =1;
			else
			{
				cmd_gauge.val--;
			}
		}
		cmd_gauge.bgcolor =0x008500;
		cmd_gauge.color_RGB_tab[0] =170;
		cmd_gauge.color_RGB_tab[1] =0;
		cmd_gauge.color_RGB_tab[2] =127;
		FT80x_F_CMD_Gauge(&cmdOffset, cmd_gauge);

		ft800memWrite32(RAM_CMD + cmdOffset, (DL_RESTORE_CONTEXT));
		cmdOffset = incCMDOffset(cmdOffset, 4);
		ft800memWrite32(RAM_CMD + cmdOffset, (DL_SAVE_CONTEXT));
		cmdOffset = incCMDOffset(cmdOffset, 4);

		//pokrto
		if (dial_up ==1)
		{
			if (cmd_dial.val > (0xFFFF-100))
			{
				dial_up =0;
				cmd_dial.val =0xFFFF;
			}
			else
			{
				cmd_dial.val =cmd_dial.val +100;
			}
		}
		else
		{
			if (cmd_dial.val < 100)
			{
				dial_up =1;
				cmd_dial.val =0;
			}
			else
			{
				cmd_dial.val =cmd_dial.val -100;
			}
		}

		cmd_dial.fgcolor =0x676767;
		cmd_dial.color_RGB_tab[0] =0;
		cmd_dial.color_RGB_tab[1] =0;
		cmd_dial.color_RGB_tab[2] =0;
		FT80x_F_CMD_Dial(&cmdOffset, cmd_dial);
		ft800memWrite32(RAM_CMD + cmdOffset, (DL_RESTORE_CONTEXT));
		cmdOffset = incCMDOffset(cmdOffset, 4);
		ft800memWrite32(RAM_CMD + cmdOffset, (DL_SAVE_CONTEXT));
		cmdOffset = incCMDOffset(cmdOffset, 4);

		//suwak
		if (slider_up ==1)
		{
			if (cmd_slider.val >=cmd_slider.range) slider_up =0;
			else cmd_slider.val++;
		}
		else
		{
			if (cmd_slider.val ==0) slider_up =1;
			else cmd_slider.val--;
		}
		cmd_slider.fgcolor =0xFFFFFF;
		cmd_slider.bgcolor =0x002040;
		FT80x_F_CMD_Slider(&cmdOffset, cmd_slider);

		//sygnalizator poczekajka
		cmd_spinner.color_RGB_tab[0] =255;
		cmd_spinner.color_RGB_tab[1] =255;
		cmd_spinner.color_RGB_tab[2] =255;
		FT80x_F_CMD_Spinner(&cmdOffset, cmd_spinner);


		ft800memWrite32(RAM_CMD + cmdOffset, (DL_RESTORE_CONTEXT));
		cmdOffset = incCMDOffset(cmdOffset, 4);
		ft800memWrite32(RAM_CMD + cmdOffset, (DL_SAVE_CONTEXT));
		cmdOffset = incCMDOffset(cmdOffset, 4);

	}
}
void Obsluga_Demo_Grafika(void)
{
extern unsigned int cmdOffset;
s_cmd_txt cmd_txt;
s_f_point f_point;
s_f_line f_line;
s_f_rects f_rects;

	if(odliczanie_3_6_s <3000)
	{
		FT80x_F_DL_Color_RGB(&cmdOffset, 255, 255, 255);
		cmd_txt.x =160;
		cmd_txt.y =35;
		cmd_txt.font =31;
		cmd_txt.options =1024;
		cmd_txt.s ="Font 31 test napi";
		FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

		FT80x_F_DL_Color_RGB(&cmdOffset, 0,85,255);
		cmd_txt.x =160;
		cmd_txt.y =70;
		cmd_txt.font =30;
		cmd_txt.options =1024;
		cmd_txt.s ="Font 30 test napisu";
		FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

		FT80x_F_DL_Color_RGB(&cmdOffset, 255,85,0);
		cmd_txt.x =160;
		cmd_txt.y =93;
		cmd_txt.font =29;
		cmd_txt.options =1024;
		cmd_txt.s ="Font 29 test napisu";
		FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

		FT80x_F_DL_Color_RGB(&cmdOffset, 85,170,0);
		cmd_txt.x =160;
		cmd_txt.y =114;
		cmd_txt.font =28;
		cmd_txt.options =1024;
		cmd_txt.s ="Font 28 test napisu";
		FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

		FT80x_F_DL_Color_RGB(&cmdOffset, 255,170,0);
		cmd_txt.x =160;
		cmd_txt.y =135;
		cmd_txt.font =27;
		cmd_txt.options =1024;
		cmd_txt.s ="Font 27 test napisu";
		FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

		FT80x_F_DL_Color_RGB(&cmdOffset, 255,0,255);
		cmd_txt.x =160;
		cmd_txt.y =150;
		cmd_txt.font =26;
		cmd_txt.options =1024;
		cmd_txt.s ="Font 26 test napisu";
		FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

		FT80x_F_DL_Color_RGB(&cmdOffset, 0,170,255);
		cmd_txt.x =160;
		cmd_txt.y =180;
		cmd_txt.font =25;
		cmd_txt.options =1024;
		cmd_txt.s ="Font 25 test napisu";
		FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

		FT80x_F_DL_Color_RGB(&cmdOffset, 255,255,0);
		cmd_txt.x =160;
		cmd_txt.y =210;
		cmd_txt.font =24;
		cmd_txt.options =1024;
		cmd_txt.s ="Font 24 test napisu";
		FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

		FT80x_F_DL_Color_RGB(&cmdOffset, 255,0,0);
		cmd_txt.x =160;
		cmd_txt.y =234;
		cmd_txt.font =23;
		cmd_txt.options =1024;
		cmd_txt.s ="Font 23 test napisu";
		FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

		FT80x_F_DL_Color_RGB(&cmdOffset, 255,255,255);
		cmd_txt.x =160;
		cmd_txt.y =250;
		cmd_txt.font =20;
		cmd_txt.options =1024;
		cmd_txt.s ="Font 20 test napisu";
		FT80x_F_CMD_Text(&cmdOffset, cmd_txt);
	}
	else
	{
		//punkt1
		f_point.color_RGB_tab[0] =0;
		f_point.color_RGB_tab[1] =85;
		f_point.color_RGB_tab[2] =0;
		f_point.x =190;
		f_point.y =50;
		f_point.size =544;//w 1/16 piksela
		FT80x_F_Point(&cmdOffset, f_point);
		//punkt2
		f_point.color_RGB_tab[0] =0;
		f_point.color_RGB_tab[1] =170;
		f_point.color_RGB_tab[2] =0;
		f_point.x =254;
		f_point.y =34;
		f_point.size =288;//w 1/16 piksela
		FT80x_F_Point(&cmdOffset, f_point);
		//punkt3
		f_point.color_RGB_tab[0] =0;
		f_point.color_RGB_tab[1] =255;
		f_point.color_RGB_tab[2] =0;
		f_point.x =272;
		f_point.y =70;
		f_point.size =104;//w 1/16 piksela
		FT80x_F_Point(&cmdOffset, f_point);
		//linia1
		f_line.color_RGB_tab[0] =170;
		f_line.color_RGB_tab[1] =0;
		f_line.color_RGB_tab[2] =0;
		f_line.x_start =300;
		f_line.y_start =20;
		f_line.x_stop =420;
		f_line.y_stop =145;
		f_line.size =6;
		FT80x_F_Line(&cmdOffset, f_line);
		//linia2
		f_line.x_start =295;
		f_line.y_start =91;
		f_line.x_stop =439;
		f_line.y_stop =36;
		f_line.size =20;
		FT80x_F_Line(&cmdOffset, f_line);
		//linia3
		f_line.x_start =370;
		f_line.y_start =30;
		f_line.x_stop =462;
		f_line.y_stop =105;
		f_line.size =1;
		FT80x_F_Line(&cmdOffset, f_line);
		//prostokt
		f_rects.color_RGB_tab[0] =85;
		f_rects.color_RGB_tab[1] =170;
		f_rects.color_RGB_tab[2] =255;
		f_rects.x1 =150;
		f_rects.y1 =120;
		f_rects.x2 =303;
		f_rects.y2 =220;
		FT80x_F_Rects(&cmdOffset, f_rects);
	}
}
