/**
  ******************************************************************************
  * File Name          : main.c
  * Description        : Main program body
  ******************************************************************************
  *
  * COPYRIGHT(c) 2015 STMicroelectronics
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "stm32f4xx_hal.h"

/* USER CODE BEGIN Includes */

/* USER CODE END Includes */

/* Private variables ---------------------------------------------------------*/
	//SPI_HandleTypeDef hspi1;

/* USER CODE BEGIN PV */
/* Private variables ---------------------------------------------------------*/

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);

/* USER CODE BEGIN PFP */
/* Private function prototypes -----------------------------------------------*/

/* USER CODE END PFP */

/* USER CODE BEGIN 0 */
// AN_312 FT800 header
#include "FT800.h"
#include "FT801_procedury.h"
#include "FT801_funkcje.h"
#include "Procedury_Demo_FT801.h"


unsigned int cmdBufferRd = 0x0000;											// Used to navigate command ring buffer
unsigned int cmdBufferWr = 0x0000;											// Used to navigate command ring buffer
unsigned int cmdOffset = 0x0000;											// Used to navigate command rung buffer

unsigned char aktywna_strona;

/* USER CODE END 0 */

int main(void)
{
int dotkniecie =0x80008000;
uint16_t poz_x, poz_y;
extern unsigned char aktywny_ekran;
extern uint32_t back_Tick, odliczanie_10ms, odliczanie_3_6_s;

  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration----------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* Configure the system clock */
  SystemClock_Config();

  /* Initialize all configured peripherals */
  FT801_Inicjacja();

  /* USER CODE BEGIN 2 */
 //inicjacja wskanikw obszaru DL i procedura kalibracji ekranu dotykowego

	do
	{
		cmdBufferRd = ft800memRead16(REG_CMD_READ);					// Read the graphics processor read pointer
		cmdBufferWr = ft800memRead16(REG_CMD_WRITE); 				// Read the graphics processor write pointer
	}while (cmdBufferWr != cmdBufferRd);							// Wait until the two registers match

	cmdOffset = cmdBufferWr;										// The new starting point the first location after the last command

	ft800memWrite32(RAM_CMD + cmdOffset, (CMD_DLSTART));			// Start the display list
	cmdOffset = incCMDOffset(cmdOffset, 4);							// Update the command pointer
	ft800memWrite32(RAM_CMD + cmdOffset, (CMD_CALIBRATE));			// kalibracja
	cmdOffset = incCMDOffset(cmdOffset, 4);							// Update the command pointer
	ft800memWrite32(RAM_CMD + cmdOffset, (DL_END));					// End the point
	cmdOffset = incCMDOffset(cmdOffset, 4);							// Update the command pointer

	ft800memWrite16(REG_CMD_WRITE, (cmdOffset));					// Update the ring buffer pointer so the graphics processor starts executing

	aktywna_strona =AKTYWNA_STRONA_1;


  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
	  do
	  {
		  if (aktywna_strona ==AKTYWNA_STRONA_2 && aktywny_ekran ==EKRAN_2_1)
		  {
			  if (back_Tick !=HAL_GetTick())
			  {
				  //odliczona kolejna 1ms
				  if (odliczanie_10ms !=0)
				  {
					  odliczanie_10ms--;
					  back_Tick =HAL_GetTick();
				  }
				  else
				  {
					  FT80x_F_DL_Start(&cmdBufferRd, &cmdBufferWr, &cmdOffset);
					  Page2_Obsluga();
					  FT80x_F_DL_End(&cmdOffset);
				  }
			  }
		  }
		  if (aktywna_strona ==AKTYWNA_STRONA_2 && aktywny_ekran ==EKRAN_2_2)
		  {
			  if (back_Tick !=HAL_GetTick())
			  {
				  //odliczona kolejna 1ms
				  if (odliczanie_10ms !=0)
				  {
					  odliczanie_10ms--;
					  back_Tick =HAL_GetTick();
				  }
				  else
				  {
					  FT80x_F_DL_Start(&cmdBufferRd, &cmdBufferWr, &cmdOffset);
					  Page2_Obsluga();
					  FT80x_F_DL_End(&cmdOffset);
					  odliczanie_10ms =10;
					  back_Tick =HAL_GetTick();
				  }
			  }
		  }
		  if (aktywna_strona ==AKTYWNA_STRONA_2 && aktywny_ekran ==EKRAN_2_3)
		  {
			  if (back_Tick !=HAL_GetTick())
			  {
				  //odliczona kolejna 1ms
				  odliczanie_3_6_s++;
				  if (odliczanie_3_6_s ==3000)	//3000ms =3s
				  {
					  FT80x_F_DL_Start(&cmdBufferRd, &cmdBufferWr, &cmdOffset);
					  Page2_Obsluga();
					  FT80x_F_DL_End(&cmdOffset);
				  }
				  if (odliczanie_3_6_s >=6000)	//6000ms =6s
				  {
					  odliczanie_3_6_s =0;
					  FT80x_F_DL_Start(&cmdBufferRd, &cmdBufferWr, &cmdOffset);
					  Page2_Obsluga();
					  FT80x_F_DL_End(&cmdOffset);
				  }
				  back_Tick =HAL_GetTick();
			  }
		  }
		  dotkniecie =ft800memRead32(0x102510);
	  }
	  while (dotkniecie ==0x80008000);

	  FT80x_F_DL_Start(&cmdBufferRd, &cmdBufferWr, &cmdOffset);

	  switch (aktywna_strona)
	  {
	  	  case AKTYWNA_STRONA_1:
		  {
			  Page1_Obsluga();
			  break;
		  }
	  	  case AKTYWNA_STRONA_2:
		  {
	  		  Page2_Obsluga();
	  		  break;
		  }
	  }


  /* USER CODE BEGIN 3 */

/*
		ft800memWrite32(RAM_CMD + cmdOffset, 0xffffff14);
		cmdOffset = incCMDOffset(cmdOffset, 4);
		ft800memWrite16(RAM_CMD + cmdOffset, 300);
		cmdOffset = incCMDOffset(cmdOffset, 2);
		ft800memWrite16(RAM_CMD + cmdOffset, 120);
		cmdOffset = incCMDOffset(cmdOffset, 2);
		ft800memWrite16(RAM_CMD + cmdOffset, 80);
		cmdOffset = incCMDOffset(cmdOffset, 2);
		ft800memWrite16(RAM_CMD + cmdOffset, OPT_NOSECS);
		cmdOffset = incCMDOffset(cmdOffset, 2);
		ft800memWrite16(RAM_CMD + cmdOffset, 8);
		cmdOffset = incCMDOffset(cmdOffset, 2);
		ft800memWrite16(RAM_CMD + cmdOffset, 24);
		cmdOffset = incCMDOffset(cmdOffset, 2);
		ft800memWrite16(RAM_CMD + cmdOffset, 0);
		cmdOffset = incCMDOffset(cmdOffset, 2);
		ft800memWrite16(RAM_CMD + cmdOffset, 0);
		cmdOffset = incCMDOffset(cmdOffset, 2);
*/

		if (dotkniecie !=0x80008000)
		{
			poz_x =dotkniecie >>16;
			poz_y =0xFFFF & dotkniecie;
s_cmd_txt cmd_txt;
			cmd_txt.x =345;
			cmd_txt.y =260;
			cmd_txt.font =20;
			cmd_txt.options =OPT_CENTER;
			cmd_txt.s ="poz.X";
			FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

			ft800memWrite32(RAM_CMD + cmdOffset, CMD_NUMBER);
			cmdOffset = incCMDOffset(cmdOffset, 4);
			ft800memWrite16(RAM_CMD + cmdOffset, 375);
			cmdOffset = incCMDOffset(cmdOffset, 2);
			ft800memWrite16(RAM_CMD + cmdOffset, 260);
			cmdOffset = incCMDOffset(cmdOffset, 2);
			ft800memWrite16(RAM_CMD + cmdOffset, 20);
			cmdOffset = incCMDOffset(cmdOffset, 2);
			ft800memWrite16(RAM_CMD + cmdOffset, OPT_CENTERY);
			cmdOffset = incCMDOffset(cmdOffset, 2);
			ft800memWrite32(RAM_CMD + cmdOffset, poz_x);
			cmdOffset = incCMDOffset(cmdOffset, 4);

			cmd_txt.x =420;
			cmd_txt.y =260;
			cmd_txt.font =20;
			cmd_txt.options =OPT_CENTER;
			cmd_txt.s ="poz.Y";
			FT80x_F_CMD_Text(&cmdOffset, cmd_txt);

			ft800memWrite32(RAM_CMD + cmdOffset, CMD_NUMBER);
			cmdOffset = incCMDOffset(cmdOffset, 4);
			ft800memWrite16(RAM_CMD + cmdOffset, 450);
			cmdOffset = incCMDOffset(cmdOffset, 2);
			ft800memWrite16(RAM_CMD + cmdOffset, 260);
			cmdOffset = incCMDOffset(cmdOffset, 2);
			ft800memWrite16(RAM_CMD + cmdOffset, 20);
			cmdOffset = incCMDOffset(cmdOffset, 2);
			ft800memWrite16(RAM_CMD + cmdOffset, OPT_CENTERY);
			cmdOffset = incCMDOffset(cmdOffset, 2);
			ft800memWrite32(RAM_CMD + cmdOffset, poz_y);
			cmdOffset = incCMDOffset(cmdOffset, 4);

		}
		FT80x_F_DL_End(&cmdOffset);

  }
  /* USER CODE END 3 */

}
/* USER CODE END WHILE */

/** System Clock Configuration
*/
void SystemClock_Config(void)
{

  RCC_OscInitTypeDef RCC_OscInitStruct;
  RCC_ClkInitTypeDef RCC_ClkInitStruct;

  __PWR_CLK_ENABLE();

  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE1);

  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSICalibrationValue = 16;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI;
  RCC_OscInitStruct.PLL.PLLM = 16;
  RCC_OscInitStruct.PLL.PLLN = 336;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV4;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  HAL_RCC_OscConfig(&RCC_OscInitStruct);

  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_SYSCLK|RCC_CLOCKTYPE_PCLK1;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;
  HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2);

  HAL_SYSTICK_Config(HAL_RCC_GetHCLKFreq()/1000);

  HAL_SYSTICK_CLKSourceConfig(SYSTICK_CLKSOURCE_HCLK);

  /* SysTick_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(SysTick_IRQn, 0, 0);
}

/* USER CODE END 4 */

#ifdef USE_FULL_ASSERT

/**
   * @brief Reports the name of the source file and the source line number
   * where the assert_param error has occurred.
   * @param file: pointer to the source file name
   * @param line: assert_param error line source number
   * @retval None
   */
void assert_failed(uint8_t* file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
    ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */

}

#endif

/**
  * @}
  */ 

/**
  * @}
*/ 

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
